/*
	Copyright 2009-2012, Sumeet Chhetri

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/
/*
 * FutureTask.cpp
 *
 *  Created on: 17-Mar-2013
 *      Author: sumeetc
 */

#include "FutureTask.h"

FutureTask::FutureTask() {
	init();
	result = NULL;
}

FutureTask::FutureTask(const int& priority) {
	setPriority(priority);
	result = NULL;
}

FutureTask::FutureTask(const int& tunit, const int& type) {
	setTunitType(tunit, type);
	result = NULL;
}

FutureTask::~FutureTask() {
	// TODO Auto-generated destructor stub
}

void* FutureTask::getResult()
{
	while(!isTaskComplete())
	{
		Thread::mSleep(1);
	}
	return result;
}

void FutureTask::taskComplete()
{
	m_mutex.lock();
	isComplete = true;
	m_mutex.unlock();
}

bool FutureTask::isTaskComplete()
{
	bool flag = false;
	m_mutex.lock();
	flag = isComplete;
	m_mutex.unlock();
	return flag;
}
